/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License specifically applicable to
 * this software at http://developer.yahoo.com/yslow/license.txt, or the general
 * form at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is: YSlow
 *
 * The Initial Developer of the Original Code is Yahoo! Inc.
 *
 * Copyright (C) 2007, Yahoo! Inc. All Rights Reserved.
 *
 * Contributor(s):
 * ***** END LICENSE BLOCK ***** */

//Create the global YSLOW namespace.
var YSLOW = YSLOW || {};
YSLOW.userAgent = 'YSlow';

var gLatestYSlowContext = false;

// Intended for use by YSlowSolo users.
// It assumes there is only one YSlowContext.
YSLOW.getYSlowContext = function(browserWindow) {
	var yslowContext = new YSLOW.YSlowContext(browserWindow);

	FirebugContext.yslowContext = yslowContext;

	yslowContext.browserDoc = browserWindow.document;
	yslowContext.yslowInit();
	yslowContext.peelerObj = new YSLOW.Peeler(yslowContext);
	yslowContext.comps = [];  // clear it out
	yslowContext.count = {};  // clear it out

	return yslowContext;
}


// Intended for use by YSlowSolo users.
// It assumes there is only one YSlowContext.
//
// type
//     The type of component to create. Must be one of the following strings: "doc", "redirect", "iframe", "xhr", "flash", "js", "css", "cssimage", or "image".
// url
//     The URL of the component, e.g., "http://us.i1.yimg.com/us.yimg.com/i/rt/yslow/logo_32x32.png".
// status
//     The HTTP status code of the response, e.g., 200 or 302.
// responseHeaders
//     The headers in a "\n" delimited string (see example below).
// responseTime
//     How long it took to fetch this component.
// responseText (optional)
//     The body of the HTTP response for non-binary component types: "doc", "iframe", "xhr", "js", and "css".
YSLOW.addComponent = function(type, url, status, responseHeaders, responseTime, responseText) {
    var compObj = new YSLOW.Component(type, url, FirebugContext.yslowContext.peelerObj);
	FirebugContext.yslowContext.peelerObj.addComponent( compObj );
	compObj.setComponentDetails(status, responseHeaders, responseText, responseTime);

	return compObj;
}


// Wrapper for getting preferences with a default.
// Returns undefined if the preference doesn't exist and no default is specified.
// Override this function for specific platforms. See yslowFirebug.js for an example.
YSLOW.getPref = function(name, defaultval) {
	return defaultval;
}
